=encoding utf8

=head1 NAME

Mail::Message::Head::Delayed - a not-read header of a Mail::Message

=head1 INHERITANCE

 Mail::Message::Head::Delayed realizes a Mail::Message::Head::Complete

 Mail::Message::Head::Delayed
   is a Mail::Message::Head
   is a Mail::Reporter

=head1 SYNOPSIS

  my $delayed = Mail::Message::Head::Delayed->new(...)
  $delayed->isa('Mail::Message::Head')  # true
  $delayed->guessBodySize               # undef
  $delayed->isDelayed                   # true

=head1 DESCRIPTION

This object is used as place-holder, to be replaced
by a L<Mail::Message::Head|Mail::Message::Head> when someone accesses the header of a message.

Extends L<"DESCRIPTION" in Mail::Message::Head|Mail::Message::Head/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Message::Head|Mail::Message::Head/"OVERLOADED">.

=over 4

=item overload: B<""> stringifaction

Inherited, see L<Mail::Message::Head/"OVERLOADED">

=item overload: B<bool> true/false

Inherited, see L<Mail::Message::Head/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Message::Head|Mail::Message::Head/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::Head|Mail::Message::Head/"Constructors">.

=over 4

=item $class-E<gt>B<build>($fields)

You cannot create a delayed header with fields.
Improves base, see L<Mail::Message::Head/"Constructors">

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Message::Head/"Constructors">

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::Head|Mail::Message::Head/"Attributes">.

=head2 The header

Extends L<"The header" in Mail::Message::Head|Mail::Message::Head/"The header">.

=over 4

=item $obj-E<gt>B<isDelayed>()

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<isEmpty>()

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<isModified>()

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<knownNames>()

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<message>( [$message] )

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<modified>( [BOOLEAN] )

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<orderedFields>()

Inherited, see L<Mail::Message::Head/"The header">

=back

=head2 Access to the header

Extends L<"Access to the header" in Mail::Message::Head|Mail::Message::Head/"Access to the header">.

=over 4

=item $obj-E<gt>B<get>( $name, [$index] )

Get the information about the header line C<$name>.  Realization will
take place.
Improves base, see L<Mail::Message::Head/"Access to the header">

=item $obj-E<gt>B<study>( $name, [$index] )

Inherited, see L<Mail::Message::Head/"Access to the header">

=back

=head2 About the body

Extends L<"About the body" in Mail::Message::Head|Mail::Message::Head/"About the body">.

=over 4

=item $obj-E<gt>B<guessBodySize>()

On a delayed head, this returns C<undef>, because when there is no header
there is also no body.

For messages in directory or network organized folders,
L<Mail::Message::size()|Mail::Message/"The message"> usually will give a figure for the whole message
without much cost.  Subtract a few hundred bytes for the header, and
you will get a good estimate.
Improves base, see L<Mail::Message::Head/"About the body">

=item $obj-E<gt>B<guessTimeStamp>()

Make a guess about when the message was originally posted.
On a delayed head, this returns C<undef>.
For messages in directory or network organized folders,
L<Mail::Message::timestamp()|Mail::Message/"The header"> usually will give a figure without much cost.

=item $obj-E<gt>B<isMultipart>()

Inherited, see L<Mail::Message::Head/"About the body">

=back

=head2 Internals

Extends L<"Internals" in Mail::Message::Head|Mail::Message::Head/"Internals">.

=over 4

=item $obj-E<gt>B<addNoRealize>($field)

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<addOrderedFields>($fields)

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<fileLocation>()

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<load>()

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<moveLocation>($distance)

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<read>($parser)

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<setNoRealize>($field)

Not possible.
Improves base, see L<Mail::Message::Head/"Internals">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::Head|Mail::Message::Head/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::Head|Mail::Message::Head/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Message::Head|Mail::Message::Head/"DETAILS">.

=head1 DIAGNOSTICS

=over 4

=item Error: attempt to set field on a delayed header.

Cast by C<setNoRealize()>

=item Error: cannot build() a delayed header.

A delayed message header cannot contain any information, so cannot be
build.  You can construct complete or subset headers.
Cast by C<build()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.01,
built on December 13, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

